Subject: Improve default value handling for NULL value fields
Description

Currently the default value handling for input fields that can be set to NULL (eval is set to null) is quite inconsistent when creating new
records:

    -  if mode is set to useOrOverridePlaceholder the field is NULL by default
    -  if this setting is not used the default value is a non empty string

Additionally it is not possible to explicitly set a NULL default value.

It would be better to if the mode does not have any influence on the default value but if it is possible to set NULL as default.

When this is handled together with #53662 backward compatibility should not be a problem because currently new records will have
NULL values by default but empty strings are stored in the database.

Related issues:
related to Core - Bug # 53662: DatabaseConnection INSERTquery does not allow ... Resolved 2013-11-15
related to TCA Reference - Bug # 56584: Default value can be set to NULL Closed 2014-03-05
duplicated by Core - Bug # 60487: File References override meta data with emp... Closed 2014-07-23

Associated revisions
Revision 6695eddf - 2014-03-19 00:41 - Alexander Stehlik

[TASK] Unify NULL default value handling

If a field is configured to allow NULL values ("eval" is set to "null")
and the default value in the TCA is explicitly set to NULL the value
will not be converted to a string.

Additionally the mode setting "useOrOverridePlaceholder" will not have
any influence any more on the default value when creating new records.

Resolves: #54412
Releases: 6.2
Documentation: #56584
Change-Id: Ica43a1af33e6f86dd042b66781acc0e9cd904cf9
Reviewed-on: https://review.typo3.org/26408
Reviewed-by: Markus Klein
Tested-by: Markus Klein
Reviewed-by: Oliver Hader
Reviewed-by: Ernesto Baschny
Reviewed-by: Stefan Neufeind
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe

History
#1 - 2013-12-14 18:02 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#2 - 2013-12-16 20:23 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#3 - 2014-01-04 18:26 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#4 - 2014-01-13 11:02 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#5 - 2014-01-13 11:20 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#6 - 2014-02-17 16:06 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#7 - 2014-03-05 20:56 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#8 - 2014-03-05 23:09 - Gerrit Code Review

2015-08-04 2/3

https://review.typo3.org/26408
https://review.typo3.org/26408
https://review.typo3.org/26408
https://review.typo3.org/26408
https://review.typo3.org/26408
https://review.typo3.org/26408
https://review.typo3.org/26408


Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26408

#9 - 2014-03-05 23:30 - Alexander Stehlik
- File screenshot_tca_config.png added

This is how it should look like in the configuration module when default is set to NULL and the patch is applied.

#10 - 2014-03-19 01:30 - Alexander Stehlik
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:6695eddf42ed2ddf5ba5cfefcaaca94616bf52d1.

Files
screenshot_tca_config.png 48.6 kB 2014-03-05 Alexander Stehlik
